package jump.libx.phase.sample;

import jump.libx.phase.PhasedMask;
import jump.libx.phase.Phaser;
import jump.libx.phase.PhaserException;
import jump.libx.phase.HandledPhaser;
import jump.libx.phase.helper.PhasedMaskHelper;
import org.apache.log4j.BasicConfigurator;
import org.apache.log4j.Logger;

/**
 * Created by neh
 * Date: 30.03.2005
 * Time: 17:31:55
 */
public class PhasedMaskedSampleClass implements PhasedMask  {

   private static Logger logger = Logger.getLogger(PhasedMaskedSampleClass.class);

   public PhasedMaskedSampleClass() {
   }

   public void start() {
   }

   public void construct() {
      //To change body of implemented methods use File | Settings | File Templates.
   }

   public void applyArguments() {
      //To change body of implemented methods use File | Settings | File Templates.
   }

   public void accessCheck() {
      //To change body of implemented methods use File | Settings | File Templates.
   }

   public void contentValidation() {
      //To change body of implemented methods use File | Settings | File Templates.
   }

   public void populateMasterControls() {
      //To change body of implemented methods use File | Settings | File Templates.
   }

   public void populateDataControls() {
      //To change body of implemented methods use File | Settings | File Templates.
   }

   public void updateDependencies() {
      //To change body of implemented methods use File | Settings | File Templates.
   }

   public void accessValidation() {
      //To change body of implemented methods use File | Settings | File Templates.
   }

   public void activate() {
      //To change body of implemented methods use File | Settings | File Templates.
   }

   public static void main( String[] args ) {

      BasicConfigurator.configure( );
      final PhasedMaskedSampleClass phasedMaskedSampleClass = new PhasedMaskedSampleClass();

      try {
         logger.debug( "ALL" );
         Phaser phaser = new Phaser( phasedMaskedSampleClass );
         phaser.invokeAll();
      } catch ( PhaserException e ) {
         e.printStackTrace();  //To change body of catch statement use File | Settings | File Templates.
      }

      try {
         logger.debug( "2,3" );
         Phaser phaser = new Phaser( phasedMaskedSampleClass );
         phaser.invoke( new int[] {2,3} );
      } catch ( PhaserException e ) {
         e.printStackTrace();  //To change body of catch statement use File | Settings | File Templates.
      }

      try {
         logger.debug( "applyArguments,contentValidation" );
         Phaser phaser = new Phaser( phasedMaskedSampleClass );
         phaser.invoke( new String[] {"applyArguments","contentValidation"} );
      } catch ( PhaserException e ) {
         e.printStackTrace();  //To change body of catch statement use File | Settings | File Templates.
      }

      HandledPhaser handledPhaser = new HandledPhaser( new Phaser( phasedMaskedSampleClass ) );
      handledPhaser.invokeAll();

      PhasedMaskHelper helper = new PhasedMaskHelper( phasedMaskedSampleClass );
      helper.construct();
      helper.reload();

   }
   
}
