package jump.libx.phase;

/**
 * Aus diesem Interface werden weitere Interfaces abgeleitet, die Methoden enthalten
 * die mit Phase Annotationen versehen sind. Objekte, die dieses Interface implementieren,
 * knnen an einen Phaser bergeben werden, der die Methden gemss ihrer Phasenreihenfolge
 * aufruft.
 * <br>
 * Beachten: Die implementierten Methoden mssen alle void liefern und drfen keine Argumente
 * erwarten.
 * <pre>
 * Created by neh
 * Date: 01.04.2005
 * Time: 09:40:39
 * </pre>
 */
public interface Phased {
}
