package jump.libx.phase.helper;

import jump.libx.phase.PhasedMask;
import jump.libx.phase.HandledPhaser;
import jump.libx.phase.Phaser;
import org.apache.log4j.Logger;

/**
 * Created by neh
 * Date: 01.04.2005
 * Time: 10:08:46
 */
public class PhasedMaskHelper {

   private static Logger logger = Logger.getLogger(PhasedMaskHelper.class);

   private PhasedMask _phasedMask = null;

   public PhasedMaskHelper( PhasedMask phasedMask ) {
      _phasedMask = phasedMask;
   }

   public void construct() {
      HandledPhaser phaser = new HandledPhaser( new Phaser( _phasedMask ) );
      logger.debug( "Constructing PhasedMask: " + _phasedMask );
      phaser.invokeAll();
   }

   public void reload() {
      HandledPhaser phaser = new HandledPhaser( new Phaser( _phasedMask ) );
      logger.debug( "Reloading PhasedMask: " + _phasedMask );
      phaser.invoke( new int[] { 1,2,3,4,5,6,7,8 } );
   }

}
