package jump.libx.phase.sample;

import jump.libx.phase.Phase;
import jump.libx.phase.PhasedMask;

import javax.swing.*;

/**
 * Created by neh
 * Date: 04.05.2005
 * Time: 15:45:02
 */
public abstract class AbstractMask extends JPanel implements PhasedMask {
   @Phase(index = 0, displayName = "Erstellung")
   public void construct() {
   }

   @Phase(index = 1, displayName = "Argumente zuweisen")
   public void applyArguments() {
   }

   @Phase(index = 2, displayName = "Zugriffsprfung")
   public void accessCheck() {
   }

   @Phase(index = 3, displayName = "Inhaltsprfung")
   public void contentValidation() {
   }

   @Phase(index = 4, displayName = "Befllung Master")
   public void populateMasterControls() {
   }

   @Phase(index = 5, displayName = "Befllung Detail")
   public void populateDataControls() {
   }

   @Phase(index = 6, displayName = "Abhngigkeiten einstellen")
   public void updateDependencies() {
   }

   @Phase(index = 7, displayName = "Plausibilisierung")
   public void accessValidation() {
   }

   @Phase(index = 8, displayName = "Aktivierung")
   public void activate() {
   }
}
